part of '../enumerable.dart';

abstract class IGrouping<TKey, TElement> implements Iterable<TElement> {
  TKey get key;
}

class _Grouping<TKey, TElement> extends Iterable<TElement>
    implements IGrouping<TKey, TElement> {
  final Iterable<TElement> _elements;

  TKey _key;

  _Grouping(TKey key, this._elements) {
    _key = key;
  }

  @override
  Iterator<TElement> get iterator {
    return _elements.iterator;
  }

  @override
  TKey get key => _key;
}
